Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs	(revision 16399)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/Solution.cs	(revision 16400)
@@ -85,10 +85,10 @@
     }
 
-    public IEnumerable<double[]> Predict(IntRange episode, int forecastHorizon) {
+    public IEnumerable<double[]> Predict(IntRange episode, int forecastHorizon, out double snmse) {
       var forecastEpisode = new IntRange(episode.Start, episode.End + forecastHorizon);
-      double nmse = double.NaN;
+
       double[] optL0;
       var random = new FastRandom(12345);
-      Problem.OptimizeForEpisodes(trees, problemData, targetVars, latentVariables, random, new[] { forecastEpisode }, 100, numericIntegrationSteps, odeSolver, out optL0, out nmse);
+      Problem.OptimizeForEpisodes(trees, problemData, targetVars, latentVariables, random, new[] { forecastEpisode }, 100, numericIntegrationSteps, odeSolver, out optL0, out snmse);
       var predictions = Problem.Integrate(
          trees,
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.Designer.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.Designer.cs	(revision 16399)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.Designer.cs	(revision 16400)
@@ -45,6 +45,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.components = new System.ComponentModel.Container();
-      this.animationTimer = new System.Windows.Forms.Timer(this.components);
       this.tableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();
       this.updateButton = new System.Windows.Forms.Button();
@@ -56,10 +54,7 @@
       this.episodeEndTextbox = new System.Windows.Forms.TextBox();
       this.trackBar = new System.Windows.Forms.TrackBar();
+      this.errorLabel = new System.Windows.Forms.Label();
       ((System.ComponentModel.ISupportInitialize)(this.trackBar)).BeginInit();
       this.SuspendLayout();
-      // 
-      // animationTimer
-      // 
-      this.animationTimer.Interval = 15;
       // 
       // tableLayoutPanel
@@ -68,7 +63,7 @@
             | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
+      this.tableLayoutPanel.AutoScroll = true;
       this.tableLayoutPanel.ColumnCount = 1;
       this.tableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50F));
-      this.tableLayoutPanel.GrowStyle = System.Windows.Forms.TableLayoutPanelGrowStyle.FixedSize;
       this.tableLayoutPanel.Location = new System.Drawing.Point(0, 109);
       this.tableLayoutPanel.Name = "tableLayoutPanel";
@@ -152,7 +147,17 @@
       this.trackBar.ValueChanged += new System.EventHandler(this.trackBar_Validated);
       // 
+      // errorLabel
+      // 
+      this.errorLabel.AutoSize = true;
+      this.errorLabel.Location = new System.Drawing.Point(190, 35);
+      this.errorLabel.Name = "errorLabel";
+      this.errorLabel.Size = new System.Drawing.Size(48, 13);
+      this.errorLabel.TabIndex = 9;
+      this.errorLabel.Text = "SNMSE:";
+      // 
       // SolutionView
       // 
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.errorLabel);
       this.Controls.Add(this.trackBar);
       this.Controls.Add(this.endLabel);
@@ -173,5 +178,4 @@
 
     #endregion
-    private System.Windows.Forms.Timer animationTimer;
     private System.Windows.Forms.TableLayoutPanel tableLayoutPanel;
     private System.Windows.Forms.Button updateButton;
@@ -183,4 +187,5 @@
     private System.Windows.Forms.TextBox episodeEndTextbox;
     private System.Windows.Forms.TrackBar trackBar;
+    private System.Windows.Forms.Label errorLabel;
   }
 }
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.cs	(revision 16399)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.cs	(revision 16400)
@@ -72,5 +72,7 @@
       // trackBar.Value = predictionEpisode.Start;
 
-      var predictions = Content.Predict(predictionEpisode, forecastHorizon).ToArray();
+      double snmse;
+      var predictions = Content.Predict(predictionEpisode, forecastHorizon, out snmse).ToArray();
+      errorLabel.Text = $"SNMSE: {snmse:e4}";
       var trainingPredictions = predictions.Take(predictionEpisode.Size).ToArray();
       var forecastPredictions = predictions.Skip(predictionEpisode.Size).ToArray();
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.resx
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.resx	(revision 16399)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Problems.DynamicalSystemsModelling/3.3/SolutionView.resx	(revision 16400)
@@ -118,6 +118,3 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
-  <metadata name="animationTimer.TrayLocation" type="System.Drawing.Point, System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
-    <value>17, 17</value>
-  </metadata>
 </root>